#
# spec file for package docbook_4 (Version 4.3)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  libxml2 sgml-skel

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext libtool libxml2 perl rpm sgml-skel

Name:         docbook_4
License:      X11/MIT, BSD
Group:        Productivity/Publishing/DocBook
Provides:     docbk_4 docbook docbook-dtd
Obsoletes:    docbk_4
Requires:     iso_ent xmlcharent
Requires:     sgml-skel libxml2
%define regcat /usr/bin/sgml-register-catalog
PreReq:       %{regcat} /usr/bin/xmlcatalog /usr/bin/edit-xml-catalog
PreReq:       sed grep awk
Autoreqprov:  on
Summary:      DocBook DTD Version 4.x
Version:      4.3
Release:      0.1
Source0:      http://www.oasis-open.org/docbook/sgml/4.1/docbk41.zip
Source1:      http://www.oasis-open.org/docbook/xml/4.1/docbkx412.zip
Source2:      docbook_4-README.SuSE
Source3:      http://www.oasis-open.org/docbook/sgml/4.2/docbook-4.2.zip
Source4:      http://www.oasis-open.org/docbook/xml/4.2/docbook-xml-4.2.zip
Source5:      CATALOG.db41xml
Source6:      CATALOG.db42xml
Source7:      CATALOG.docbook_4
Source8:      http://www.docbook.org/sgml/4.3/docbook-4.3.zip
Source9:      http://www.docbook.org/xml/4.3/docbook-xml-4.3.zip
Source10:     http://www.docbook.org/rng/4.3/docbook-rng-4.3.zip
Source11:     http://www.docbook.org/xsd/4.3/docbook-xsd-4.3.zip
Source12:     CATALOG.db43xml
Patch0:       docbook-4-3-cat.diff
Patch1:       docbook-4-3.diff
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
BuildArchitectures: noarch
URL:          http://www.oasis-open.org/docbook/

%description
Docbook is used to produce technical documentation.  This package has
SGML and XML versions included.



Authors:
--------
    Eve L. Maler <elm@arbortext.com>
    Terry Allen <tallen@sonic.net>
    Norman Walsh <ndw@nwalsh.com>

%define INSTALL install -m755 -s
%define INSTALL_DIR install -d -m755
%define INSTALL_DATA install -m644
%define INSTALL_SCRIPT install -m755
%define sgml_dir %{_datadir}/sgml
%define sgml_docbook_dir %{sgml_dir}/docbook
%define sgml_docbook_dtd_dir %{sgml_docbook_dir}/dtd
%define sgml_docbook_custom_dir %{sgml_docbook_dir}/custom
%define sgml_docbook_style_dir %{sgml_docbook_dir}/stylesheet
%define xml_dir %{_datadir}/xml
%define xml_docbook_dir %{xml_dir}/docbook
%define xml_docbook_dtd_dir %{xml_docbook_dir}/schema/dtd
%define xml_docbook_rng_dir %{xml_docbook_dir}/schema/rng
%define xml_docbook_xsd_dir %{xml_docbook_dir}/schema/xsd
%define xml_docbook_custom_dir %{xml_docbook_dir}/custom
%define xml_docbook_style_dir %{xml_docbook_dir}/stylesheet
%define sgml_config_dir /var/lib/sgml
%define sgml_sysconf_dir %{_sysconfdir}/sgml
%define xml_config_dir /var/lib/xml
%define xml_sysconf_dir %{_sysconfdir}/xml
%prep
%setup -n $RPM_PACKAGE_NAME -c -T
cp -p $RPM_SOURCE_DIR/%{name}-README.SuSE README.SuSE
%{INSTALL_DIR} dtd/4.{1,2,3} 4.{1,2,3}xml
pushd dtd/4.1
  unzip -q -a %{SOURCE0}
popd
pushd 4.1xml
  unzip -q -a %{SOURCE1}
popd
pushd dtd/4.2
  unzip -q -a %{SOURCE3}
popd
pushd 4.2xml
  unzip -q -a %{SOURCE4}
popd
pushd dtd/4.3
  unzip -q -a %{SOURCE8}
popd
pushd 4.3xml
  unzip -q -a %{SOURCE9}
popd
%patch -p 1 -P 1 -p 0
# CATALOG.* files
cp %{S:5} %{S:6} %{S:7} %{S:12} .
chmod -R a+rX,g-w,o-w .
find . -type f | xargs chmod a-x

%build
CATALOG=docbook_41.xml
# # build root catalog fragment
xmlcatbin=/usr/bin/xmlcatalog
$xmlcatbin --create --noout $CATALOG
docbookdir=%{xml_docbook_dtd_dir}/4.1
$xmlcatbin --noout --add "public" \
    "-//OASIS//ELEMENTS DocBook XML Information Pool V4.1.2//EN" \
    "file://$docbookdir/dbpoolx.mod" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//DTD DocBook XML V4.1.2//EN" \
    "file://$docbookdir/docbookx.dtd" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//ENTITIES DocBook XML Character Entities V4.1.2//EN" \
    "file://$docbookdir/dbcentx.mod" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//ENTITIES DocBook XML Notations V4.1.2//EN" \
    "file://$docbookdir/dbnotnx.mod" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//ENTITIES DocBook XML Additional General Entities V4.1.2//EN" \
    "file://$docbookdir/dbgenent.mod" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//ELEMENTS DocBook XML Document Hierarchy V4.1.2//EN" \
    "file://$docbookdir/dbhierx.mod" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//DTD XML Exchange Table Model 19990315//EN" \
    "file://$docbookdir/soextblx.dtd" $CATALOG
$xmlcatbin --noout --add "public" \
    "-//OASIS//DTD DocBook XML CALS Table Model V4.1.2//EN" \
    "file://$docbookdir/calstblx.dtd" $CATALOG
$xmlcatbin --noout --add "rewriteSystem" \
    "http://www.oasis-open.org/docbook/xml/4.1.2" \
    "file://$docbookdir" $CATALOG
$xmlcatbin --noout --add "rewriteURI" \
    "http://www.oasis-open.org/docbook/xml/4.1.2" \
    "file://$docbookdir" $CATALOG
# === iso
isodir=$docbookdir/ent
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Publishing//EN//XML" \
    "file://$isodir/iso-pub.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Greek Letters//EN//XML" \
    "file://$isodir/iso-grk1.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Box and Line Drawing//EN//XML" \
    "file://$isodir/iso-box.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Greek Symbols//EN//XML" \
    "file://$isodir/iso-grk3.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Math Symbols: Negated Relations//EN//XML" \
    "file://$isodir/iso-amsn.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Numeric and Special Graphic//EN//XML" \
    "file://$isodir/iso-num.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Alternative Greek Symbols//EN//XML" \
    "file://$isodir/iso-grk4.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Diacritical Marks//EN//XML" \
    "file://$isodir/iso-dia.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Monotoniko Greek//EN//XML" \
    "file://$isodir/iso-grk2.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Math Symbols: Arrow Relations//EN//XML" \
    "file://$isodir/iso-amsa.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Math Symbols: Ordinary//EN//XML" \
    "file://$isodir/iso-amso.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Russian Cyrillic//EN//XML" \
    "file://$isodir/iso-cyr1.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES General Technical//EN//XML" \
    "file://$isodir/iso-tech.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Math Symbols: Delimiters//EN//XML" \
    "file://$isodir/iso-amsc.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Latin 1//EN//XML" \
    "file://$isodir/iso-lat1.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Math Symbols: Binary Operators//EN//XML" \
    "file://$isodir/iso-amsb.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Latin 2//EN//XML" \
    "file://$isodir/iso-lat2.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Added Math Symbols: Relations//EN//XML" \
    "file://$isodir/iso-amsr.ent" $CATALOG
$xmlcatbin --noout --add "public" \
    "ISO 8879:1986//ENTITIES Non-Russian Cyrillic//EN//XML" \
    "file://$isodir/iso-cyr2.ent" $CATALOG
# ====
%define FOR_ROOT_CAT for-catalog-%{name}-%{version}-%{release}.xml
CATALOG=etc/xml/$CATALOG
rm -f %{FOR_ROOT_CAT}.tmp
$xmlcatbin --noout --create %{FOR_ROOT_CAT}.tmp
for v in 4.2 4.3; do
  cat42=%{xml_docbook_dtd_dir}/$v/catalog.xml
  for s in \
    "-//OASIS//DTD DocBook XML V${v}//EN" \
    "-//OASIS//DTD DocBook CALS Table Model V${v}//EN" \
    "-//OASIS//DTD XML Exchange Table Model 19990315//EN" \
    "-//OASIS//ELEMENTS DocBook Information Pool V${v}//EN" \
    "-//OASIS//ELEMENTS DocBook Document Hierarchy V${v}//EN" \
    "-//OASIS//ENTITIES DocBook Additional General Entities V${v}//EN" \
    "-//OASIS//ENTITIES DocBook Notations V${v}//EN" \
    "-//OASIS//ENTITIES DocBook Character Entities V${v}//EN"
   do
   $xmlcatbin --noout --add "delegatePublic" "$s" \
     "file://$cat42" %{FOR_ROOT_CAT}.tmp
  done
  $xmlcatbin --noout --add "delegateSystem" \
    "http://www.oasis-open.org/docbook/xml/${v}" \
    "file://$cat42" %{FOR_ROOT_CAT}.tmp
  $xmlcatbin --noout --add "delegateURI" \
    "http://www.oasis-open.org/docbook/xml/${v}" \
    "file://$cat42" %{FOR_ROOT_CAT}.tmp
  $xmlcatbin --noout --add "rewriteSystem" \
    "http://www.oasis-open.org/docbook/xml/${v}" \
    "file://%{xml_docbook_dtd_dir}/${v}" %{FOR_ROOT_CAT}.tmp
  $xmlcatbin --noout --add "delegatePublic" \
    "ISO 8879:1986" \
    "file:///$CATALOG" %{FOR_ROOT_CAT}.tmp
done
# 41xml
for s in \
  "-//OASIS//DTD DocBook XML V4.1" \
  "-//OASIS//ELEMENTS DocBook Information Pool V4.1" \
  "-//OASIS//ELEMENTS DocBook Document Hierarchy V4.1" \
  "-//OASIS//ENTITIES DocBook Additional General Entities V4.1" \
  "-//OASIS//ENTITIES DocBook Notations V4.1" \
  "-//OASIS//ENTITIES DocBook Character Entities V4.1"
 do
 $xmlcatbin --noout --add "delegatePublic" "$s" \
   "file:///$CATALOG" %{FOR_ROOT_CAT}.tmp
done
$xmlcatbin --noout --add "delegateSystem" \
  "http://www.oasis-open.org/docbook/xml/4.1" \
  "file:///$CATALOG" %{FOR_ROOT_CAT}.tmp
$xmlcatbin --noout --add "delegateURI" \
  "http://www.oasis-open.org/docbook/xml/4.1" \
  "file:///$CATALOG" %{FOR_ROOT_CAT}.tmp
# Create tag
sed '/<catalog/a\
  <group id="%{name}-%{version}-%{release}">
/<\/catalog/i\
  </group>' \
  %{FOR_ROOT_CAT}.tmp > %{FOR_ROOT_CAT}

%install
if [ ! "x" = "x$RPM_BUILD_ROOT" ] ; then
  rm -fr $RPM_BUILD_ROOT
  %{INSTALL_DIR} $RPM_BUILD_ROOT
fi
%{INSTALL_DIR} $RPM_BUILD_ROOT%{sgml_config_dir}
%{INSTALL_DIR} $RPM_BUILD_ROOT%{xml_config_dir}
%{INSTALL_DATA} CATALOG.* $RPM_BUILD_ROOT%{sgml_config_dir}
# for CATALOG.* links
%define my_all_cat docbook_4 db41xml db42xml db43xml
for v in 4.1 4.2 4.3; do
  vl=${v/\.}
  %{INSTALL_DIR} $RPM_BUILD_ROOT%{sgml_docbook_dtd_dir}/$v
  %{INSTALL_DATA} dtd/${v}/* $RPM_BUILD_ROOT%{sgml_docbook_dtd_dir}/${v}
  %{INSTALL_DIR} $RPM_BUILD_ROOT%{xml_docbook_dtd_dir}/$v
  cp -a ${v}xml/* $RPM_BUILD_ROOT%{xml_docbook_dtd_dir}/$v
  ln -s %{xml_docbook_dtd_dir}/$v $RPM_BUILD_ROOT%{sgml_docbook_dtd_dir}/${v}xml
  ln -sf %{sgml_config_dir}/CATALOG.db${vl}xml \
    $RPM_BUILD_ROOT%{sgml_dir}/CATALOG.db${vl}xml
done
ln -sf %{sgml_docbook_dtd_dir}/4.1 $RPM_BUILD_ROOT%{sgml_dir}/%{name}.1
ln -sf %{sgml_config_dir}/CATALOG.%{name} \
  $RPM_BUILD_ROOT%{sgml_dir}/CATALOG.%{name}
ln -sf %{sgml_config_dir}/CATALOG.%{name} \
  $RPM_BUILD_ROOT%{sgml_dir}/CATALOG.docbk41
cat_dir=%{buildroot}/etc/xml
%{INSTALL_DIR} $cat_dir
%{INSTALL_DATA} %{FOR_ROOT_CAT} docbook_41.xml $cat_dir
# rng
%{INSTALL_DIR} $RPM_BUILD_ROOT%{xml_docbook_rng_dir}/4.3
unzip -q -a -d $RPM_BUILD_ROOT%{xml_docbook_rng_dir}/4.3 %{S:10}

%pre
lk=%{sgml_dir}/db42xml
[ -L $lk ] && rm -f $lk || :
# in case of an update check for old dirs (affected systems =< SL 9.0)
old="db41xml db42xml docbook_4 docbook_4.2 docbook_4.1"
pushd %{sgml_dir} >/dev/null
{
  for f in $old; do
    [ -d $f ] && echo $f || :
  done
} >> /var/adm/SuSEconfig/run-sgmldir-links

%post
if [ -x %{regcat} ]; then
  for c in %{my_all_cat}; do
    %{regcat} -a  %{sgml_dir}/CATALOG.$c \
      >/dev/null 2>&1 || true
  done
fi
edit-xml-catalog --group --catalog /etc/xml/suse-catalog.xml \
  --add /etc/xml/%{FOR_ROOT_CAT}
exit 0

%postun
if [ "$1" = "0" -a -x %{regcat} ]; then
  for c in %{my_all_cat}; do
    %{regcat} -r %{sgml_dir}/CATALOG.$c \
      >/dev/null 2>&1 || true
  done
fi
edit-xml-catalog --group --catalog /etc/xml/suse-catalog.xml \
  --del %{name}-%{version}-%{release}
exit 0

%clean
rm -fr $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%config %{sgml_config_dir}/CATALOG.*
%doc README.SuSE
%{sgml_dir}/CATALOG.*
%{sgml_docbook_dtd_dir}/4.1
%{sgml_docbook_dtd_dir}/4.2
%{sgml_docbook_dtd_dir}/4.3
%{sgml_docbook_dtd_dir}/4.1xml
%{sgml_docbook_dtd_dir}/4.2xml
%{sgml_docbook_dtd_dir}/4.3xml
%{xml_docbook_dtd_dir}/4.1
%{xml_docbook_dtd_dir}/4.2
%{xml_docbook_dtd_dir}/4.3
%{xml_docbook_rng_dir}/4.3
%config %{xml_sysconf_dir}/docbook_41.xml
%config %{xml_sysconf_dir}/%{FOR_ROOT_CAT}
%dir %{sgml_dir}/docbook/dtd
%dir %{xml_dir}
%dir %{xml_docbook_dir}
%dir %{xml_docbook_dir}/schema
%dir %{xml_docbook_dtd_dir}
%dir %{xml_docbook_rng_dir}

%changelog -n docbook_4
* Mon Mar 01 2004 - ke@suse.de
- In %%postun check for the update case.
* Tue Feb 24 2004 - hmacht@suse.de
- building as non-root
* Tue Feb 10 2004 - ke@suse.de
- Move XML DTDs to /usr/share/xml/docbook/schema/dtd.
* Fri Jan 30 2004 - ke@suse.de
- Add links pointing from the SGML hierarchy to the XML files.
* Thu Jan 22 2004 - ke@suse.de
- Adjust directories according to FHS 2.3:
  * Move XML DTDs to /usr/share/xml/docbook.
  * Move SGML DTDs to /usr/share/sgml/docbook.
  * Keep CATALOG.* files in /usr/share/sgml for the time being.
  * Provide compatibility links for SL =< 9.0 (log this info in
  /var/adm/SuSEconfig/run-sgmldir-links for later processing).
* Fri Jul 11 2003 - ke@suse.de
- Remove disturbing link %%{_datadir}/sgml/db42xml via %%pre.
* Wed Apr 30 2003 - ke@suse.de
- Use the "//XML" suffix for Formal Public Identifiers of XML ISO
  entity sets.
* Tue Apr 29 2003 - ke@suse.de
- Use /etc/xml/suse-catalog.xml instead of /etc/xml/catalog.
* Tue Apr 29 2003 - ke@suse.de
- Use <group> sectioning in  /etc/xml/catalog.
* Mon Apr 28 2003 - ke@suse.de
- Use edit-xml-catalog in %%post/%%postun for managing /etc/xml/catalog.
* Tue Apr 15 2003 - ke@suse.de
- Fix %%preun/%%postun scripts: Use %%postun only to avoid nuking catalog
  entries during update; add rewriteSystem statement.
  Reported by Gernot Hillier [# 26270].
* Mon Nov 25 2002 - ke@suse.de
- Use sgml-register-catalog to populate /etc/sgml/catalog.
* Fri Nov 15 2002 - ke@suse.de
- Also for the 4.2 DTD provide convenience links for psgml.
* Wed Nov 06 2002 - ke@suse.de
- Map DocBook 4.0 system identifiers to 4.1.
* Wed Aug 14 2002 - ke@suse.de
- Add delegatePublic and delegateSystem for DocBook DTD 4.1 to the XML
  catalog.  Thus scrollkeeper-update can make use of local resources.
  Reported by Thorsten Kukuk and Olaf Hering [# 17646].
- Add more files to the uninstall cleanup scripts.
* Mon Aug 12 2002 - ke@suse.de
- Don't use hardcoded version number ("41") when building the the 42
  SGML Open Catalog for the XML DTD.
  Reported by Norbert Eicker.
* Thu Aug 08 2002 - ke@suse.de
- Add the third slash for "file:///' again (necessary because I removed
  one from the variable assignemnt).
* Wed Aug 07 2002 - mls@suse.de
- Fixed exit status of postinstall script.
* Wed Aug 07 2002 - ke@suse.de
- Drop the SuSEconfig script; reported by Thorsten Kukuk [# 17448].
* Tue Aug 06 2002 - ke@suse.de
- Add missing PreReq (libxml2, zlib); reported by Thorsten Kukuk [#
  17435].
* Fri Jul 26 2002 - ke@suse.de
- SuSEconfig.docbook_4: Remove CATALOG file with length of zero.
- Add "DTD DocBook XML V4.1" to /etc/xml/docbook_41.xml.
- Drop superfluous slashes ("file:///", not "file:////").
- Fix FPI names in /etc/xml/docbook_41.xml.
* Fri Jul 26 2002 - ke@suse.de
- Actually install the catalogs and make sure applications will find
  more DTD.
* Wed Jul 24 2002 - ke@suse.de
- Add SGML and XML DTD version 4.2.
- Simplify catalog creation and management.
* Mon Jun 24 2002 - ke@suse.de
- Don't install XML ISO entity links; instead require xmlcharent.
- Start to prepare for release 4.2.
  Mon May  6 10:40:29 CEST 2002 - ke@suse.de
- Don't try to call the SuSEconfig script as long as the system isn't
  mounted on "/".
* Fri May 03 2002 - ke@suse.de
- Provide /sbin/conf.d/SuSEconfig.%%{name} to initialize catalogs
  later if xmlcatalog isn't available at installation time.
* Thu May 02 2002 - ke@suse.de
- Require libxml2 to install proper /etc/xml catalog files.
- Maintain /etc/xml catalog files via %%post/%%postun.
* Mon Aug 27 2001 - ke@suse.de
- Rename README.SuSE to docbook_4-README.SuSE.
- Install DTD and ENTITY links using install-dtd.sh to support
  Emacs/PSGML.
- Cleanup spec file.
- Add sgml-skel to 'neededforbuild'.
* Tue Mar 13 2001 - ke@suse.de
- Rename package: docbk_4 -> docbook_4 (cf. docbook_3).
- Update XML DTD (version 4.1.2).
- Add 'OVERRIDE YES' to XML catalog.
- Add README.SuSE.
* Tue Jun 27 2000 - ke@suse.de
- Correct CATALOG entries for entities.
* Tue Jun 20 2000 - ke@suse.de
- Initial package: version 4.1.
